=== debian/changelog ===
findlib (1.9.6-1build4) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 16:47:41 +0200

findlib (1.9.6-1build3) noble; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 15 Nov 2023 13:37:04 +0100

findlib (1.9.6-1build2) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Nov 2023 08:12:57 +0100

findlib (1.9.6-1build1) lunar; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 16 Feb 2023 08:26:05 +0100

findlib (1.9.6-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Mon, 23 Jan 2023 11:00:21 +0100
