=== debian/changelog ===
findlib (1.9.8-1build2) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 25 Oct 2025 13:50:14 +0200

findlib (1.9.8-1build1) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 10:19:15 +0200

findlib (1.9.8-1) unstable; urgency=medium

  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Tue, 11 Feb 2025 17:00:44 +0100

findlib (1.9.6-3) unstable; urgency=medium

  * Remove packages that are already provided by stdlib

 -- Stéphane Glondu <glondu@debian.org>  Thu, 08 Aug 2024 01:58:11 +0200

findlib (1.9.6-2) unstable; urgency=medium

  * Fix build with OCaml 5.x

 -- Stéphane Glondu <glondu@debian.org>  Sat, 15 Jun 2024 07:24:02 +0200
