=== debian/rules ===
--- 
+++ 
@@ -9,7 +9,6 @@
 %:
 	dh $@ --with ocaml,bash-completion
 
-.PHONY: override_dh_auto_configure
 override_dh_auto_configure:
 	./configure \
 		-config /etc/ocamlfind.conf \
@@ -20,7 +19,6 @@
 		-with-toolbox
 	sed -i '/INSTALLFILE/s/.*/INSTALLFILE = cp/' Makefile.config
 
-.PHONY: override_dh_auto_build
 override_dh_auto_build:
 	$(MAKE)
 ifeq ($(OCAML_HAVE_OCAMLOPT),yes)
@@ -32,9 +30,17 @@
   OCAMLINIT_SED += -e '\,raw_spacetime/META,d'
 endif
 
+# Adjustments for OCaml 5.x
+ifeq (,$(filter 5.%,$(OCAML_ABI)))
+  OCAMLINIT_SED += -e 's/^META: //'
+else
+  OCAMLINIT_SED += -e '/^META: /d'
+  dynlink_subdir = dynlink
+  export dynlink_subdir
+endif
+
 export OCAMLINIT_SED
 
-.PHONY: override_dh_auto_install
 override_dh_auto_install:
 	$(MAKE) install prefix=$(CURDIR)/debian/tmp
 # rm ocamlc.opt and similar settings, they're not avail everywhere in debian
@@ -45,13 +51,19 @@
 	test -d $(CURDIR)/debian/tmp/usr/share/man/man3 && \
 		rmdir $(CURDIR)/debian/tmp/usr/share/man/man3
 
+execute_after_dh_install:
+# remove packages that are already provided by stdlib
+	for p in bytes; do \
+	  if [ -d $(OCAML_STDLIB_DIR)/$$p ]; then \
+	    rm -rf $(CURDIR)/debian/libfindlib-ocaml$(OCAML_STDLIB_DIR)/$$p; \
+	  fi; \
+	done
+
 # do not strip executables on bytecode executables (is this still needed?)
 ifneq ($(OCAML_HAVE_OCAMLOPT),yes)
-.PHONY: override_dh_strip
 override_dh_strip:
 endif
 
-.PHONY: override_dh_auto_clean
 override_dh_auto_clean:
 	if [ -f Makefile.config ]; then $(MAKE) clean; fi
 	-rm -f Makefile.config ocargs.log src/findlib/ocaml_args.ml
